# Shipment by DDT Alpha

## Shipment by Alpha DDT - GET

This endpoint returns the shipment information together with their labels in the available formats, exactly as [Shipment](/gsped-api-english-version/spedizioni-e-dintorni/shipment.md#shipment-get), but using the **alphanumeric reference** as a query parameter.

{% hint style="info" %}
The alphanumeric reference must be unique in order to use this endpoint
{% endhint %}

**If the user to whom the apikey is associated operates with several usernames** and the alphanumeric references risk to be identical, it is possible to use the additional parameter **client\_id**, valorised with the whole one indicating on which data to further filter the query.

{% hint style="info" %}
The list of the client\_id of a user is given by Gsped at the end of each configuration.
{% endhint %}

## Shipment information retrieval

<mark style="color:blue;">`GET`</mark> `https://api.gsped.it/[INSTANCE]/ShipmentByDdtalpha`

It retrieves the shipment information using the alphanumeric reference as search field.

#### Query Parameters

| Name                                         | Type   | Description                            |
| -------------------------------------------- | ------ | -------------------------------------- |
| ddt\_alpha<mark style="color:red;">\*</mark> | String | Alphanumeric reference of the shipment |
| client\_id                                   | String | Client id                              |

#### Headers

| Name                                        | Type   | Description            |
| ------------------------------------------- | ------ | ---------------------- |
| x-api-key<mark style="color:red;">\*</mark> | String | API Key given by Gsped |

{% tabs %}
{% tab title="200: OK Shipment data" %}

```javascript
{
  "client_id": 390,
  "cod_destinatario": "",
  "colli": 1,
  "contrassegno": 0,
  "corriere": 2,
  "date_req_cons": "0000-00-00 00:00:00",
  "ddt_alpha": "55880",
  "ddt_num": 70059765,
  "merce": "",
  "note_sender": "",
  "origine": "",
  "peso": 5.6,
  "preavviso_telefonico": "",
  "rcpt_addr": "MOLO VENEZIA 10",
  "rcpt_cap": 34121,
  "rcpt_city": "TRIESTE",
  "rcpt_contact": "test contact2",
  "rcpt_country_code": "IT",
  "rcpt_email": "test@gsped.com",
  "rcpt_name": "Test destinatariotesto aggiuntivo",
  "rcpt_phone": 1234545789,
  "rcpt_prov": "TS",
  "servizio": 11,
  "tipo_incasso": 0,
  "valore": 0,
  "valore_doganale": 1,
  "volume": 0,
  "status": 0,
  "fid_partenza": "MI10",
  "num_serie": 0,
  "num_spedizione": "WS12345678",
  "date_upd": "0000-00-00 00:00:00",
  "error": "",
  "sender_name": "Test Mittente",
  "sender_addr": "Via Cavour 15",
  "sender_cap": 20123,
  "sender_city": "Milano",
  "sender_contact": "test contact",
  "sender_prov": "MI",
  "sender_country_code": "IT",
  "sender_email": "test@gsped.com",
  "label_jpg": [
    "base64 encoded label string"
  ],
  "label_pdf": [
    "base64 encoded label string"
  ],
  "label_zpl": [
    "ZPL label string"
  ],
  "id": 70059765,
  "daticolli": [
    {
      "peso": 5.6,
      "volume": 0,
      "larghezza": 0,
      "lunghezza": 0,
      "altezza": 0,
      "n_collo": 1,
      "barcode": "4646466464test4646"
    }
  ],
  "tnt_options": [],
  "tracking_link": "",
  "sender_phone": 41321234,
  "dropshipping": 0,
  "valuta": "",
  "al_piano": "",
  "al_sabato": "",
  "reso_contestuale": "",
  "fermo_deposito": 0,
  "note": "",
  "centro_costo": "",
  "sda_servizio": "",
  "date_req_ritiro": "0000-00-00 00:00:00",
  "opening_time": "00:00:00",
  "closing_time": "00:00:00",
  "barcode": "T70059765",
  "ups_uap_id": 0,
  "sda_id_fermoposta": "",
  "flag_reso": 0,
  "note_2": "",
  "documenti": 0,
  "brt_num_segnacollo_da": 0,
  "brt_num_segnacollo_a": 0,
  "confermato": 1,
  "ups_signature_required": 0,
  "id_pickup": null,
  "data_consegna_prevista": "0000-00-00 00:00:00",
  "sda_accessori": 0,
  "codice_merce_fercam": "",
  "milkman_tracking_code": "WS24881051",
  "opening_time2": "00:00:00",
  "closing_time2": "00:00:00",
  "chi_paga": 0,
  "dangerous_goods": "",
  "vat_seller": "",
  "vat_buyer": "",
  "generic_service_point": "",
  "user_id": 0,
  "sender_eori": "",
  "rcpt_eori": "",
  "link_pickup_booking": ""
}
```

{% endtab %}

{% tab title="400: Bad Request Invalid input" %}

```javascript
{
  "error": "DDT_alpha spedizione non indicata(1)"
}
```

{% endtab %}

{% tab title="403: Forbidden Invalid Credentials" %}

```javascript
{
  "status": false,
  "error": "Invalid API key "
}
```

{% endtab %}

{% tab title="404: Not Found Shipment not found" %}

```javascript
{
  "error": "Spedizione non trovata (10)"
}
```

{% endtab %}
{% endtabs %}

### Example Snippets

{% tabs %}
{% tab title="PHP" %}

```php
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test1234567",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "GET",
  CURLOPT_POSTFIELDS => "",
  CURLOPT_HTTPHEADER => [
    "x-api-key: YOUR-API-KEY"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

{% endtab %}

{% tab title="PYTHON" %}

```python
import http.client

conn = http.client.HTTPSConnection("api.gsped.it")

payload = ""

headers = { 'x-api-key': "YOUR-API-KEY" }

conn.request("GET", "/sandbox/ShipmentByDdtalpha?ddt_alpha=test1234567", payload, headers)

res = conn.getresponse()
data = res.read()

print(data.decode("utf-8"))
```

{% endtab %}

{% tab title="GO" %}

```go
package main

import (
	"fmt"
	"net/http"
	"io/ioutil"
)

func main() {

	url := "https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test1234567"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("x-api-key", "YOUR-API-KEY")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := ioutil.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

{% endtab %}

{% tab title="C#" %}

```csharp
var client = new HttpClient();
var request = new HttpRequestMessage
{
    Method = HttpMethod.Get,
    RequestUri = new Uri("https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test1234567"),
    Headers =
    {
        { "x-api-key", "YOUR-API-KEY" },
    },
};
using (var response = await client.SendAsync(request))
{
    response.EnsureSuccessStatusCode();
    var body = await response.Content.ReadAsStringAsync();
    Console.WriteLine(body);
}
```

{% endtab %}

{% tab title="cURL" %}

```shell
curl --request GET \
  --url 'https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test1234567' \
  --header 'x-api-key: YOUR-API-KEY'
```

{% endtab %}
{% endtabs %}

## Shipment by Alpha DDT - DELETE

## Delete a shipment

<mark style="color:red;">`DELETE`</mark> `https://api.gsped.it/[INSTANCE]/ShipmentByDdtalpha`

Delete a shipment using the alphanumeric reference as search field.

#### Query Parameters

| Name                                         | Type   | Description                            |
| -------------------------------------------- | ------ | -------------------------------------- |
| ddt\_alpha<mark style="color:red;">\*</mark> | String | Alphanumeric reference of the shipment |
| client\_id                                   | String | Client ID                              |

#### Headers

| Name                                        | Type   | Description            |
| ------------------------------------------- | ------ | ---------------------- |
| x-api-key<mark style="color:red;">\*</mark> | String | APi Key given by Gsped |

{% tabs %}
{% tab title="200: OK Successfully deleted" %}

```javascript
{
  "error": ""
}
```

{% endtab %}

{% tab title="400: Bad Request Invalid Input " %}

```javascript
{
    // Response
}
```

{% endtab %}

{% tab title="400: Bad Request Not unique DDT" %}

```javascript
{
  "error": "ddt_alpha non univoco"
}
```

{% endtab %}

{% tab title="403: Forbidden Invalid Apikey" %}

```javascript
{
    // Response
}
```

{% endtab %}

{% tab title="404: Not Found Shipment not found" %}

```javascript
{
  "error": "Spedizione non trovata (10)"
}
```

{% endtab %}
{% endtabs %}

## Example Snippets

{% tabs %}
{% tab title="PHP" %}

```php
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test123456",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "DELETE",
  CURLOPT_POSTFIELDS => "",
  CURLOPT_HTTPHEADER => [
    "x-api-key: YOUR-API-KEY"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

{% endtab %}

{% tab title="PYTHON" %}

```python
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test123456",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "DELETE",
  CURLOPT_POSTFIELDS => "",
  CURLOPT_HTTPHEADER => [
    "x-api-key: YOUR-API-KEY"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

{% endtab %}

{% tab title="GO" %}

```go
package main

import (
	"fmt"
	"net/http"
	"io/ioutil"
)

func main() {

	url := "https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test123456"

	req, _ := http.NewRequest("DELETE", url, nil)

	req.Header.Add("x-api-key", "YOUR-API-KEY")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := ioutil.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

{% endtab %}

{% tab title="C#" %}

```csharp
var client = new HttpClient();
var request = new HttpRequestMessage
{
    Method = HttpMethod.Delete,
    RequestUri = new Uri("https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test123456"),
    Headers =
    {
        { "x-api-key", "YOUR-API-KEY" },
    },
};
using (var response = await client.SendAsync(request))
{
    response.EnsureSuccessStatusCode();
    var body = await response.Content.ReadAsStringAsync();
    Console.WriteLine(body);
}
```

{% endtab %}

{% tab title="cURL" %}

```shell
curl --request DELETE \
  --url 'https://api.gsped.it/sandbox/ShipmentByDdtalpha?ddt_alpha=test123456' \
  --header 'x-api-key: YOUR-API-KEY'
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://apidocs.gsped.com/gsped-api-english-version/spedizioni-e-dintorni/shipment-by-ddt-alpha.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
